#include <QPalette>
#include <QProcess>
#include <QDebug>

#include "idle.h"

Idle::Idle(PlaylistItem *item, QWidget *parent)
    : QLabel(parent)
    , Runnable()
{
    m_time = item->time();
    setBlackBackground();

    QLabel::connect(&m_timer, SIGNAL(timeout()), this, SLOT(onTimeout()));
}

void Idle::setBlackBackground()
{
    QPalette p;
    p.setColor(QPalette::Background, Qt::black);
    QLabel::setAutoFillBackground(true);
    QLabel::setPalette(p);
}

void Idle::run()
{
    qDebug() << "Starting idle";
    QProcess p;
#ifdef __arm__
    p.start("sudo",QStringList()<<"/opt/vc/bin/tvservice"<< "-p");
    p.waitForFinished();
    p.start("/opt/vc/bin/tvservice",QStringList()<<"-o");
    p.waitForFinished();
#else
    p.start("xset",QStringList()<<"dpms"<<"force"<<"off");
    p.waitForFinished();
#endif
    m_timer.start(1000 * m_time);
}

void Idle::onTimeout()
{
    m_timer.stop();
    emit(end());
}

void Idle::stop()
{
    m_timer.stop();
}
