#ifndef PDF_H
#define PDF_H

#include <QLabel>
#include <QTimer>
#include <poppler-qt4.h>

#include "runnable.h"
#include "playlistitem.h"

class PDF : public QLabel, public Runnable
{
    Q_OBJECT

public:
    PDF(PlaylistItem *item, QWidget *parent);
    void run();
    void stop();

private:
    QString m_uri;
    Poppler::Document* m_document;
    int m_pageNb;
    QPixmap m_pixmap;

    void setBlackBackground();

private slots:
    void nextPage();

signals:
    void end();
};

#endif
