#include <QTime>
#include <QTimer>
#include <QDebug>

#ifndef RUNNABLE_H
#define RUNNABLE_H

class Runnable
{
public:
    virtual void run() = 0;
    virtual void stop() = 0;
    void pause()
    {
        if(m_timer.isActive()){
            m_remainingTime = m_time - m_elapsed.elapsed();
            m_timer.stop();
            qDebug()<<"Pause";
        }
        else{
            m_elapsed.restart();
            m_timer.start();
            qDebug()<<"Resume";
        }
    }
    bool isActive(){
        return m_timer.isActive();
    }

protected:
    QTimer m_timer;
    QTime m_elapsed;
    int m_time;
    int m_remainingTime;
};
#endif
